#!/usr/bin/perl

$tape=$ARGV[0];
$device=$ARGV[1];

if ($device eq "")
{
	$device="/dev/mmcblk0";
}

@cset=(	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	#0x0n
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	#0x1n
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x11,0x17,0x15,0x1a,0x16,0x1b,0x18,	#0x2n
	0x1c,0x1d,0x1e,0x1f,0x20,0x21,0x22,0x23,0x24,0x25,0x00,0x00,0x00,0x00,0x00,0x00,	#0x3n
	0x00,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,0x30,0x31,0x32,0x33,0x34,	#0x4n
	0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,0x10,0x18,0x11,0x00,0x16,	#0x5n
	0x00,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,0x30,0x31,0x32,0x33,0x34,	#0x6n
	0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,0x10,0x18,0x11,0x00,0x00		#0x7n
);

if (-e $device)
{
	print "reading from $device tape $tape\n";
}
else
{
	die "Device $device does not exist\n";
}

$tape=int($tape);

if (($tape<0) || ($tape>255))
{
	die "Tape $tape is out of range (0..255)\n";
}

for($i=0;$i<=31;$i++)
{
	printf("%02d ",$i);
	$block=32*$tape+$i;
	$cmd="dd if=$device of=temp.bin bs=16384 skip=$block count=1 2>/dev/null";
	system(`$cmd`);
	open(BREAD,"temp.bin");
	binmode(BREAD);
	for($k=0;$k<16384;$k++)
	{
		read(BREAD,$tdata[$k],1);
	}
	close(BREAD);
	if(ord($tdata[0]) < 128)
	{
		$fname="";
		for($k=0;$k<10;$k++)
		{
			$zchar=ord($tdata[$k]);
			$pchar="_";
			for($l=32;$l<128;$l++)
			{
				if(($zchar==$cset[$l]) && ($pchar eq "_"))
				{
					$pchar=chr($l);
				}
			}
			$fname.=$pchar;
		}
		print $fname;
	}
	else
	{
		print "----------";
	}
	print "\n";
}
	$cmd="rm -f temp.bin";
	system(`$cmd`);
