#!/usr/bin/perl

$fmuster="*.P";
@fnames=<${fmuster}>;
$maxfile=$#fnames;
@fnames=sort(@fnames);

$tape=$ARGV[0];
$device=$ARGV[1];
$format=$ARGV[2];

if($device eq "-f")
{
	$device="/dev/mmcblk0";
	$format="-f";
}

if($device eq "")
{
	$device="/dev/mmcblk0";
}

@cset=(	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	#0x0n
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	#0x1n
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x11,0x17,0x15,0x1a,0x16,0x1b,0x18,	#0x2n
	0x1c,0x1d,0x1e,0x1f,0x20,0x21,0x22,0x23,0x24,0x25,0x00,0x00,0x00,0x00,0x00,0x00,	#0x3n
	0x00,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,0x30,0x31,0x32,0x33,0x34,	#0x4n
	0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,0x10,0x18,0x11,0x00,0x16,	#0x5n
	0x00,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,0x30,0x31,0x32,0x33,0x34,	#0x6n
	0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,0x10,0x18,0x11,0x00,0x00		#0x7n
);

if (-e $device)
{
	print "writing to device $device\n";
}
else
{
	die "Device $device does not exist\n";
}

$tape=int($tape);

if(($tape <0) || ($tape>255))
{
	die "Tape $tape is out of range (0..255)\n";
}

if($format eq "-f")
{
	print "format tape $tape\n";
	open(BWRITE,">temp.bin");
	binmode(BWRITE);
	for($i=0;$i<16384;$i++)
	{
		print BWRITE chr(255);
	}
	close(BWRITE);

	for($i=0;$i<=31;$i++)
	{
		$block=32*$tape+$i;
		$cmd="dd if=temp.bin of=$device bs=16384 seek=$block count=1 2>/dev/null";
		system(`$cmd`);
	}
}


for($k=0;$k<=$maxfile;$k++)
{
	$infile=$fnames[$k];
	$fname=$fnames[$k];
	$fname=~ /\./;
	$fname=$`;

	$dlen= -s $infile;

	$free=99;
	for($i=0;$i<=31;$i++)
	{
		if($free==99)
		{
			$block=32*$tape+$i;
			$cmd="dd if=$device of=temp.bin bs=16384 skip=$block count=1 2>/dev/null";
			system(`$cmd`);
			open(BREAD,"temp.bin");
			binmode(BREAD);
			read(BREAD,$fbyte,1);
			close(BREAD);
			if(ord($fbyte)==255)
			{
				$free=$i;
			}
		}
	}


	if ($free==99) 
	{
		die ("no free space");
	}
	else
	{
		print "write $infile to file $free\n";
	}

	$block=32*$tape+$free;


	open(BREAD,$infile);
	binmode(BREAD);

	$fname.="          ";

	for($i=0;$i<16384;$i++)
	{
		$tdata[$i]=255;	
	}


	for($i=0;$i<10;$i++)
	{
		$tdata[$i]=$cset[ord(substr($fname,$i,1))];	
	}

	$lolen=$dlen%256;
	$hilen=($dlen-$lolen)/256;

	$tdata[10]=$lolen;
	$tdata[11]=$hilen;

	$dindex=256;

	for($i=0;$i<$dlen;$i++)
	{
		read(BREAD,$tbyte,1);
		$tdata[$dindex]=ord($tbyte);
		$dindex++;
	}

	close(BREAD);

	open(BWRITE,">temp.bin");
	binmode(BWRITE);
	for($i=0;$i<16384;$i++)
	{
		print BWRITE chr($tdata[$i]);	
	}
	close(BWRITE);

	$cmd="dd if=temp.bin of=$device bs=16384 seek=$block count=1 2>/dev/null";
	system(`$cmd`);
}
	$cmd="rm -f temp.bin";
	system(`$cmd`);

